<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListVpnGroupReq StructType
 * @subpackage Structs
 */
class ListVpnGroupReq extends AbstractStructBase
{
    /**
     * The returnedTags
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var LVpnGroup
     */
    public $returnedTags;
    /**
     * The searchCriteria
     * @var SearchCriteria
     */
    public $searchCriteria;
    /**
     * The skip
     * Meta informations extracted from the WSDL
     * - documentation: It will be used only when first tag is specified.
     * - minOccurs: 0
     * @var int
     */
    public $skip;
    /**
     * The first
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $first;
    /**
     * The sequence
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var int
     */
    public $sequence;
    /**
     * Constructor method for ListVpnGroupReq
     * @uses ListVpnGroupReq::setReturnedTags()
     * @uses ListVpnGroupReq::setSearchCriteria()
     * @uses ListVpnGroupReq::setSkip()
     * @uses ListVpnGroupReq::setFirst()
     * @uses ListVpnGroupReq::setSequence()
     * @param LVpnGroup $returnedTags
     * @param SearchCriteria $searchCriteria
     * @param int $skip
     * @param int $first
     * @param int $sequence
     */
    public function __construct(LVpnGroup $returnedTags = null, SearchCriteria $searchCriteria = null, $skip = null, $first = null, $sequence = null)
    {
        $this
            ->setReturnedTags($returnedTags)
            ->setSearchCriteria($searchCriteria)
            ->setSkip($skip)
            ->setFirst($first)
            ->setSequence($sequence);
    }
    /**
     * Get returnedTags value
     * @return LVpnGroup
     */
    public function getReturnedTags()
    {
        return $this->returnedTags;
    }
    /**
     * Set returnedTags value
     * @param LVpnGroup $returnedTags
     * @return ListVpnGroupReq
     */
    public function setReturnedTags(LVpnGroup $returnedTags = null)
    {
        $this->returnedTags = $returnedTags;
        return $this;
    }
    /**
     * Get searchCriteria value
     * @return SearchCriteria|null
     */
    public function getSearchCriteria()
    {
        return $this->searchCriteria;
    }
    /**
     * Set searchCriteria value
     * @param SearchCriteria $searchCriteria
     * @return ListVpnGroupReq
     */
    public function setSearchCriteria(SearchCriteria $searchCriteria = null)
    {
        $this->searchCriteria = $searchCriteria;
        return $this;
    }
    /**
     * Get skip value
     * @return int|null
     */
    public function getSkip()
    {
        return $this->skip;
    }
    /**
     * Set skip value
     * @param int $skip
     * @return ListVpnGroupReq
     */
    public function setSkip($skip = null)
    {
        // validation for constraint: int
        if (!is_null($skip) && !is_numeric($skip)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($skip)), __LINE__);
        }
        $this->skip = $skip;
        return $this;
    }
    /**
     * Get first value
     * @return int|null
     */
    public function getFirst()
    {
        return $this->first;
    }
    /**
     * Set first value
     * @param int $first
     * @return ListVpnGroupReq
     */
    public function setFirst($first = null)
    {
        // validation for constraint: int
        if (!is_null($first) && !is_numeric($first)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($first)), __LINE__);
        }
        $this->first = $first;
        return $this;
    }
    /**
     * Get sequence value
     * @return int|null
     */
    public function getSequence()
    {
        return $this->sequence;
    }
    /**
     * Set sequence value
     * @param int $sequence
     * @return ListVpnGroupReq
     */
    public function setSequence($sequence = null)
    {
        // validation for constraint: int
        if (!is_null($sequence) && !is_numeric($sequence)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sequence)), __LINE__);
        }
        $this->sequence = $sequence;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return ListVpnGroupReq
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
